<?php
/*

 $Id: help.php,v 1.13 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /tmp/maintain/docs/help.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
/*

/*!
	@header Help Document
	The help page the controls, viewing, editing and creating help documents. needs to be added to libglue
*/


/* Start House Keeping */

	require "../modules/config.php";

	// do anything that needs to be done here
        if (!check_session()) { logout(); }
	

	// setup the user env.
	setup_user_environment($action, $zone_id);

/* End House Keeping */

// create the object we need
$conf['help'] = new Help($ident);

/*!
	@function  edit
	@discussion Are we editing? if so is there acutally something that we are editing?
*/
if ($action == "edit" or $action == "create") {
	show_template(header); 
	$conf['help'] = new Help($ident);
	show_template(help_form); 
	show_template(footer);
} // edit

/*!
	@function show_comments
	@discussion Show all comments for $object_id
	@param $object_id	The ID of the object we need to view
*/
elseif ($action == "show_comments") {

	$object_history = new ObjectHistory($object_type,$object_id);
	$comments = $object_history->get_all_history($object_id,$object_type);

	show_template(header);

	require ($conf['prefix'] ."/templates/show_comments.inc"); 

	show_template(footer);

} // show_comments

/*!
	@function update
	@discussion Are we updating? if so run update_help 
*/
elseif ($action == "update") {

	show_template(header);
	$conf['help']->update_help($help_ident, $help_content);

	if ($conf['error']->get_status(help_update)) {  
		$conf['error']->show_message('help_update');
	} // if get status
	else {
		echo "The $help_ident document has been updated with the following content\n<hr />";
		echo stripslashes($help_content);
		$items = array();
		$items[] = "<a href=\"" . $conf['web_path'] . "/help.php?action=edit&amp;ident=$help_ident\">[ Edit \"$help_ident\" Document ]</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/help.php?action=create\">[ Create New Document ]</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/help.php?action=view\">[ View Documents ]</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/admin.php\">[ Admin ]</a>";
		$conf['ui']->display_top_widget($items);

	} // else

	show_template(footer);
} // update

/*!
	@function add
	@discussion If we are done creating a new document run add_help
*/
elseif ($action == "add") {
	show_template(header);
	$conf['help']->add_help($help_ident, $help_content);
	if ($conf['error']->get_status(help_new))  { 
		$conf['error']->show_message('help_new');
	} // if status
	else {
		echo "The document $help_ident has been created correctly<br /><br />\n";
		echo stripslashes($help_content);

		$items = array();
		$items[] = "<a href=\"" . $conf['web_path'] . "/help.php?action=edit&amp;ident=$help_ident\">[ Edit \"$help_ident\" Document ]</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/help.php?action=create\">[ Create New Document ]</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/help.php?action=view\">[ View Documents ]</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/admin.php\">[ Admin ]</a>";
		$conf['ui']->display_top_widget($items);

	} // else

	show_template(footer);
} // add

/*!
	@function view
	@discussion If we are viewing then throw it over to the kveton mojo
*/
elseif ($action == "view")
	{

	show_template(header);
	echo "<p align=\"center\"><font class=\"header1\">Help Documents</font></p>";

	// Setup the query using the view class.
	$user->view = new View("SELECT * FROM help");

	// If $sort_type then let's init the view
	if ($sort_type)  {
		$user->view->initialize($sort_type, $sort_offset);
	}
	else {
		$user->view->initialize('ident', $sort_offset);
	}			

	$help_docs = $conf['help']->view_help($user->view->get_query());

	$conf['ui']->show_help($help_docs);
	show_template(footer);

} // view action

// If we want to delete but it's not confirmed, show confirmation
elseif ($action == "delete" and $confirm != "1") {

	show_template(header);
	$conf['ui']->show_confirm($conf['web_path'] . "/help/php?action=delete&amp;ident=$ident&amp;confirm=1", "Are you sure you want to delete the $ident document?");
	show_template(footer);

	}
// If we want to delete and it's confirmed... nuke the document
elseif ($action == "delete" and $confirm == "1")
	{
	show_template(header);
	$results = $conf['help']->delete_help($ident);
	if ($conf['error']->get_status(help_delete)) {
		$conf['error']->show_message('help_delete');
	}
	else {
		echo "<p align=\"center\"><font class=\"header1\">$ident help document deleted</font><br /><br />";
		echo "<a href=\"" . $conf['web_path'] . "/help.php?action=view\">[ View Documents ]</a>&nbsp;&nbsp;";
		echo "<a href=\"" . $conf['web_path'] . "/admin.php\">[ Admin Page ]</a></p>";
	}
	show_template(footer);
} // delete

// If we are unable to figure out what document it is...
elseif ($conf['help']->content <= " " and $action != "edit") { show_template(style); ?>

<p align="center">
<font class="fatalerror">Error Unable to find the help document: <?= $ident; ?></font>
</p>
<? 
// All else fails just dump the document out there... 
} else { show_template(style); 
?>
<body bgcolor="<?= $conf['color']->bg['body_common']; ?>">
<table border="1" cellpadding="0" width="385" height="100%" cellspacing="0" bgcolor="<?= $conf['color']->bg['body_common']; ?>">
<tr><td valign="top">
<p align="left"><a href="#" ONCLICK="self.close(); return false" Language="javascript">[Close Window]</a></p>
<?= $conf['help']->content; ?>
<p align="left"><a href="#" ONCLICK="self.close(); return false" Language="javascript">[Close Window]</a></p>
</td></tr>
</table>
<? 
} 
?>
