<?php

/*

 $Id: create_host.php,v 1.54 2004/04/05 21:20:25 philips Exp $
 $Source: /tmp/maintain/docs/create_host.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.   

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Create Host 
	The create-a-host wizard mojo ... we put the form here so the user
	can get immediate feedback on the things that are possibly wrong
	with the form.
*/

/* Start House Cleaning */
	require "../modules/config.php";

	// do anything that needs to be done here
        if (!check_session()) { logout(); }
	
	// setup the user environment
	setup_user_environment($action, $zone_id);
/* End House Cleaning */


// do whatever you have to to update the host
//   the $conf['error'] object gets updated automatically
if ( $not_first_visit ) {


	// create needed objects
	$host = new Host(0);
	$range = new Range($range_id);

        // if they used the admin select
        if ($domain_select == "admin") { $domain_id = $admin_domain_id; }

	// If they have selected use default domain....
	if ($use_default_domain) { $domain_id = $range->get_default_domain($conf['zone']->id);  }
	
        // if they didn't selecte a non-default workgroup
        if (!$workgroup_id || !$use_workgroup_id) {
	        if ($range->default_workgroup) { $workgroup_id = $range->default_workgroup; }
	        else { 
			$workgroup = $conf['zone']->get_default_workgroup(); 
			$workgroup_id = $workgroup->workgroup;
		}
        }

	// Create last object
	$domain = new Domain($domain_id);
	
        //force lowercase on the hardware address
        $ha =  $conf['ui']->clean_hardware_address($ha);

	$host->check_hostname($name, $domain);

        if (!$conf['zone']->has_domain_access($domain_id) AND !$user->is_admin) {
		$conf['error']->add_error('domain',$conf['zone']->name . " does not have access to $domain->name");
        }

	if ($expire) { 
		$expire = $conf['ui']->clean_expire_date($expire);
		if (time() > $expire) { 
			$conf['error']->add_error('expire',"Invalid Expire date set in the past");
		}
		if ($expire == -1) { 
			$conf['error']->add_error('expire',"Invalid Expire value. Example 03/27/1984 (MM/DD/YYYY)");
		}
	} 
	

	if ( $ha != '000000000000' ) {
		$host->check_hardware_address($ha,0,$range_id,$range->subnet);
	}

	if (!$domain->name) { 
		$conf['error']->add_error('domain',"Please Specify a Domain");
	}

	// if its dynamic or they are specifing a IP we shouldn't do this test
	if ( $range->type != 'dynamic' && ! $specified_ip) {
		$host->check_ip_range($range_id);
	}

	// if they have checked use default_domain then we need to make sure the range has one
	if ($use_default_domain && !$range->get_default_domain($conf['zone']->id)) {
		$conf['error']->add_error('default_domain', "Selected Range does not have a default domain");
	}

	if (!$workgroup_id && $use_workgroup_id) { 
		$conf['error']->add_error('ip_range', "Error no default workgroup found in range");
	}

	// check the default ttl
	if (!is_numeric($conf['default_host_ttl'])) { 
		$conf['error']->add_error('name',"Error in Config default TTL is not numeric");
	}

	if ($conf['default_host_ttl'] < 300) {
		$conf['error']->add_error('name',"Error in Config default TTL is less than 300");
	}

	
	//if they have specified a ip then we need to do a bunch of checking
	if ($specified_ip) { 

		// Create needed objects
		$ip_obj = new Ip(0);

		//First check to make sure it's really an IP
		if (!$ip_obj->is_dotted_quad($specified_ip)) {
                        $conf['error']->add_error('specified_ip', 'Invalid IP Address Entered');
		}

		$ip_int = $ip_obj->ip2int($specified_ip);

		//Now let's make sure it isn't in use.
		$sql = "SELECT host.id FROM host WHERE ip='$ip_int'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		//make sure we didn't find anything
		if ($results->id) { 
			$conf['error']->add_error('specified_ip',"Error this address is already in use");
		}

		//now check to make sure it isn't in a dynamic range
		$sql = "SELECT id FROM ranges WHERE start<='$ip_int' AND end>='$ip_int'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		$results = mysql_fetch_object($db_results);

		$test_range = new Range($results->id);

		if ($test_range->type == "dynamic" or $test_range->type == "ddns") { 
			$conf['error']->add_error('specified_ip',"You can not add a specific ip in a dynamic range");
		} //test for dynamic range

		if (!$test_range->has_zone($conf['zone']->id) && !$user->is_admin) {
			$conf['error']->add_error('specified_ip',"The Specified IP is not in the current zone");
		} 
		
		$found = false;
		
		//for use if we havn't found errors set $ip->id to the good stuff
		$ip = new Ip($ip_int);

	} //use_specified_ip

	// Check mx information if they also want to create a mx record
	if ($create_mx) {
		
		$mx = new MX(0);
		$mx->check_name($name,$domain,$priority,$server);
		$mx->check_server($mx_dest);
	}
	
	// looks good ... create the host
	if ( ! $conf['error']->error_state AND $user->has_access($conf['zone']->id)) {

		if ( $range->type == 'dynamic' && !$specified_ip) {
			$ip->ip_int = 0;
			$dynamic_range = $range->id;
		}
		elseif (!$specified_ip) {
			$ip = $range->get_free_ip_address();
		}

			// if they are using the default domain
		if ($use_default_domain) {
			$domain_id = $range->get_default_domain($conf['zone']->id);
		}
	
		//If they have decided to use the existing os type
		if ($use_gen_os) { 
			$os = $generated_os;
		}

		//If they have decided to use the existing hardware type
		if ($use_gen_type) {
			$type = $generated_type;
		}

		// If they are creating a mx do the work now..
		if ($create_mx) {
			$mx_id = $mx->new_item($name,$mx_dest,$domain_id,$priority,$conf['zone']->id,$conf['default_mx_ttl']);
			$mx = new MX($mx_id);
		}

		$host_id = $conf['zone']->create_host($name, $domain_id, $ip->ip_int, $dynamic_range, $ha, $os, $type, $location, $serial, $other_id, $range_id, $workgroup_id,$user->username,$purchase_date,$po_number,$warranty_date,$owning_unit,$user_id,$expire,$conf['default_ttl']);
		
		$host = new Host($host_id);
		$host->object_history->update($user->username,$comment);
		// woohoo!!! lets send them to the confirmation page
		$action = "confirmation";
	}

	// an error has occured lets get ready to re-display
	else {
		$expire = date("m/d/Y",$expire);
		$user->host_view = $host_view;

	} // error

}

show_template('header');

if ($action == "confirmation") {

	// Get the object_history information
	$history = $host->object_history->get_history();

	$body_text = "The host $host->name has been created in " . $host->zone->name;
	if ($create_mx) {
		$body_text .= "<br />The MX $mx->name has also been created in " . $conf['zone']->name;
	}
	$body_text = "<br />" . $conf['ui']->show_live_time($history->date,"Host");
	$conf['ui']->display_confirmation("Host $host->name created <a href=\"" . $conf['web_path'] . "/create_host.php\" >[Create Another Host]</a>",$body_text, $conf['web_path'] . "/host.php?action=show_host&amp;host_id=$host_id");
} // confirmation

else {
	require ($conf['prefix'] . "/templates/show_create_host.inc");
} // else
?>

<? show_template('footer'); ?>

