<?
/*

 $Id: domain.php,v 1.24 2004/05/25 17:34:34 philips Exp $
 $Source: /tmp/maintain/docs/domain.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Domain Document
	All of the admin related domain stuff
*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
        if (!check_session()) { logout(); }
	

	setup_user_environment($action, $zone_id);

/* End House Keeping */

// create the domain object form the domain_id if it's passed
if ($domain_id) { $domain = new Domain($domain_id); }

// start display mojo
show_template('header');

?>
<p align="left"><font class="header1">Manage Domains</font></p>
<?
	
/*!
	@function update_name
	@discussion update the name of the domain. 
*/
if ($action == "update_name") {

	if (!$user->is_admin) { 
		$conf['ui']->show_access_denied();
		exit();
	}

        // first things first, lets check and make sure that the fields are val$
        if ($domain->name != $name) { $domain->check_name($name,$domain_id); }

	// everything checks out, let's roll
        if (!$conf['error']->error_state) {

                //update the mojo!
                $domain->update_name($name);
                $conf['ui']->display_confirmation("Domain name updated", "The $domain->name has been changed to $name.</b>", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain_id");
	} // end if no error

        else {
                $action = "show_domain";
	} // else

} // update_name

/*!
	@function update_comment
	@discussion Update the comment on a domain. 
*/
elseif ($action == "update_comment") {

	$domain->object_history->update($user->username,$comment);
        $conf['ui']->display_confirmation("Domain Comment updated", "The Comment has been changed.</b>", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain_id");

} // update_comment

/*!
	@action update_status
	@discussion update the status on a domain
		enabled or disable
*/
elseif ($action == 'update_status') {

	$domain->set_enabled($newstatus); 
	$string = $domain->get_enabled_string();
	$conf['ui']->display_confirmation("Domain Status Changed", "$domain->name has been set to $string", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain_id");
	
} // update_status


/*!
	@function add_zone
	@discussion if we are adding a zone
*/
elseif ($action == "add_zone") {
  
	if (!$user->is_admin) { 
		$conf['ui']->show_access_denied();
		exit();
	}

	$zone = new Zone($zone_id);
	
	if ($domain->check_zone($zone->id)) { 
		$conf['zone']->add_domain($zone->id,$domain->id);
		$conf['ui']->display_confirmation("$domain->name added to $zone->name","The Domain $domain->name has been added to the list of valid domains for $zone->name", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain->id");
	}

} // add_zone

/*!
	@function remove_zone
	@discussion removeing a zone mapping
*/
elseif ($action == "remove_zone") {

	if (!$user->is_admin) { 
		$conf['ui']->show_access_denied();
		exit();
	}

	$zone = new Zone($zone_id);
	$conf['zone']->remove_domain($zone_id, $domain_id);
	$conf['ui']->display_confirmation("$domain->name removed from $zone->name", "The Domain $domain->name has been removed as a valid choice for $zone->name", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain_id");	
} // remove_zone

/*!
	@function delete_domain
	@discussion delete the domain
*/
elseif ($action == "delete_domain") {

	if (!$user->is_admin) { 
		$conf['ui']->show_access_denied();
		exit();
	}

	$domain->delete_domain($domain->id);
	$conf['ui']->display_confirmation("$domain->name has been delete", "The Domain $domain->name has been removed from Maintain.", $conf['web_path'] . "/domain.php?action=show_domains");
} // delete_domain
	
/*****************
 DISPLAY IF BLOCK
*****************/

/*!
	@function show_domains
	@discussion Display the domains
*/
if ($action == "show_domains") {	

	//create the view
	if ($zone_id) { 
		$sql = "SELECT domain.id FROM domain,zone_domain WHERE zone_domain.domain = domain.id AND zone_domain.zone = '$zone_id'";
	}
	else {
		$sql = "SELECT * FROM domain";
	}

	if (!$user->view) {
		$user->view = new View($sql);
	}

	if ($sort_type) {
		$user->view->initialize($sort_type,$sort_offset);
	}
	else {
		$user->view->initialize('id', $sort_offset);
	}
	
	$domains = $conf['ui']->get_domains();

	$total_items = mysql_num_rows(mysql_query($user->view->get_sql(), $conf['dbh']));

	if ($total_items > "0") {
		// if there are results run the view
		$conf['script'] = "domain.php";
		$conf['ui']->show_domains($domains, $total_items);
	}
	else {
		//ahhh no domains... somethin bad just went down.. I didn't do it!
		echo "<p align=\"center\"><font class=\"fatalerror\">No Domains Found!</font></p>";
	}

} // show_domains

/*!
	@function show_domain	
	@discussion Display a single domain 
*/
elseif ($action == "show_domain") {
	$conf['ui']->show_domain($domain, $action_type);
} // show_domain

/*!
	@function confirm_remove_zone
	@discussion removing a zone confirmation message
*/
elseif ($action == "confirm_remove_zone" ) {

	//first let's check for the children, if there are children they aren't allowed to nuke it.
	$zone = new Zone($zone_id);
	$child = new Child("zone_domain",$domain_id,$zone_id);

	if ($child->has_children)  {
		$conf['ui']->display_confirmation("<font class=\"fatalerror\">Fatal Error, $child->total child objects found.</font>", "Unable to remove $domain->name from $zone->name due to child objects. Please remove the below child objects and try again", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain_id"); 
		$child->show_children();
	} 
	elseif (!($cnames AND $mxs AND $hosts))  {
		//let's confirm they want to blow it up!
		$conf['ui']->show_confirm($conf['web_path'] . "/domain.php?action=remove_zone&amp;domain_id=$domain_id&amp;zone_id=$zone_id", "Are you sure you want to remove $domain->name as a valid domain for $zone->name");
	}

} // confirm_remove_zone

/*!
	@function delete_domain
	@discussion removing a domain confirmation message
*/
elseif ($action == "confirm_delete_domain") {

	//first let's make sure there aren't any children
	$child = new Child("domain",$domain_id,0,new Domain($domain_id));
	if ($child->has_children) {
		$conf['ui']->display_confirmation("<font class=\"fatalerror\">Fatal Error, $child->total child objects found</font>", "Unable to delete $domain->name due to the below child objects. Please remove them and try again", $conf['web_path'] . "/domain.php?action=show_domain&domain_id=$domain->id");
		$child->show_children();
	}
	elseif (!($cnames AND $mxs AND $hosts AND $zones)) {
		//let's confirm they want to blow it up
		$conf['ui']->show_confirm($conf['web_path'] . "/domain.php?action=delete_domain&amp;domain_id=$domain_id", "Are you sure you want to delete the domain $domain->name");
	}
} // confirm_delete_domain

show_template('footer'); 

?>
