<?php
/*

 $Id: search.php,v 1.17 2004/07/07 20:40:41 philips Exp $
 $Source: /tmp/maintain/modules/class/search.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Search Class
	This is just so we can store/keep the search vars..... 
	This class does nothing more than hold the form results in $conf['search']

*/

class Search {
	var $form_type;			//Advanced/Simple Search form
	var $string;		    //The actual Search
	var $field;			    //The search field
	var $type;			    //Fuzzy or Exact search?
	var $zone;			    //All, Mine or Specific Zone search
	//The following only apply to IP searches
	var $start_range;	    //IP Start Range
	var $end_range;		    //End Range

	function Search ($form_type,$string,$field,$type,$zone,$start_range,$end_range) {
		//Set the Vars	
		$this->form_type   = $form_type;
		$this->string	   = $string;
		$this->field	   = $field;
		$this->type	   = $type;
		$this->zone	   = $zone;
		$this->start_range = $start_range;
		$this->end_range   = $end_range;
		
	} // Search

	/*
	Search hosts... First we check if they have a sql statement. if true return hosts
	if false then create base sql query dependent upon search_field. Next add zone
	search conditions depending upon search_zone. Lastly using the generated mysql
	query return an array of the stuff we are looking for
	*/
	function search_object($search_field, $search_zone,$search_string,$search_type,$oldsql = 0) {
		global $conf, $user;

		//set these global because we make the view in here
		//bad habit I know!
		global $sort_type, $sort_offset;
		
		/*		
		#######################################
		Generate the Base SQL Statements
		#######################################
		*/

		// If we've already created the sql let's just get the hosts array and get on with it
		// cheeseball fix, we have to know if we are passing a sql statement for later
		if ($oldsql) {
			$sql = $oldsql;
		}
		//doing a fully qualified domain search
		elseif ($search_field == "fqd") {
			$data = split_hostname($search_string);
			if ($search_type == "exact") { $sql = "SELECT host.id FROM host,domain WHERE host.domain = domain.id AND domain.name ='$data->domain' AND host.name = '$data->name' "; }
			if ($search_type == "fuzzy") { $sql = "SELECT host.id FROM host,domain WHERE host.domain = domain.id AND domain.name LIKE '$data->domain' AND host.name LIKE '$data->name' "; }
		} 
		//doing a fqd cname search
		elseif ($search_field == "fqd_cname") {
			$data = split_hostname($search_string);
			$name = $data->name;
			$domain = $data->domain;
			if ($search_type == "exact") { $sql = "SELECT zone_cname.id FROM zone_cname,domain WHERE zone_cname.domain = domain.id AND domain.name ='$domain' AND zone_cname.name ='$name' "; }
			if ($search_type == "fuzzy") { $sql = "SELECT zone_cname.id FROM zone_cname,domain WHERE zone_cname.domain = domain.id AND domain.name LIKE '$domain' AND zone_cname.name LIKE '$name' "; }
		} 
		//doing a fqd mx search
		elseif ($search_field == "fqd_mx") {
			$data = split_hostname($search_string);
			$name = $data->name;
			$domain = $data->domain;
			if ($search_type == "exact") { $sql = "SELECT zone_mx.id FROM zone_mx,domain WHERE zone_mx.domain = domain.id AND domain.name ='$domain' AND zone_mx.name='$name' "; }
			if ($search_type == "fuzzy") { $sql = "SELECT zone_mx.id FROM zone_mx,domain WHERE zone_mx.domain = domain.id AND domain.name LIKE '$domain' AND zone_mx.name LIKE '$name' "; }

		}
		elseif ($search_field == "host_history") {
			if ($search_type == "exact") { $sql = "SELECT host.id FROM host WHERE host.name ='$search_string' "; }
			if ($search_type == "fuzzy") { $sql = "SELECT host.id FROM host WHERE host.name LIKE '$search_string' "; }
		}
		//doing a fuzzy IP search
		elseif ($search_field == "fuzzy_ip") {
			$ip_start = IP::ip2int($search_string[0]);
			$ip_end = IP::ip2int($search_string[1]);
			$sql = "SELECT id FROM host WHERE ip<='$ip_end' AND ip>='$ip_start'";
		}

		//doing a range search 
		elseif ($search_field == "range_search") {
			$ip = new Ip();
			$ip_start = $ip->ip2int($search_string[0]);
			$ip_end = $ip->ip2int($search_string[1]);
			$sql = "SELECT id FROM ranges WHERE end <= '$ip_end' AND start >= '$ip_start'";
		}

		//hardware type search
		elseif ($search_field == "hardware_type") {
			if ($search_type == "exact") { $sql = "SELECT * FROM host WHERE type='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM host WHERE type LIKE '$search_string' "; }
		}
		//doing a host domain name search
		elseif ($search_field == "domain_name") {
			if ($search_type == "exact") { $sql = "SELECT host.id FROM host,domain WHERE host.domain = domain.id AND domain.name='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT host.id FROM host,domain WHERE host.domain = domain.id AND domain.name LIKE '$search_string' "; }
		}
		//username search mojo time!
		elseif ($search_field == "user") {
			if ($search_type == "exact") { $sql = "SELECT DISTINCT username FROM zone_user WHERE username='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT DISTINCT username FROM zone_user WHERE username LIKE '$search_string' "; }
		}
		//domain name search
		elseif ($search_field == "domain") {
			if ($search_type == "exact") { $sql = "SELECT * FROM domain WHERE name='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM domain WHERE name LIKE '$search_string' "; }
		}
		// we are searching for cnames
		elseif ($search_field == "cname") {
			// Create our base sql statement
			if ($search_type == "exact") { $sql = "SELECT * FROM zone_cname WHERE name='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM zone_cname WHERE name LIKE '$search_string' "; }
		}
		//we are searching for cname servers
		elseif ($search_field == "cserver") {
			// create the base sql statemnet
			if ($search_type == "exact") { $sql = "SELECT * FROM zone_cname WHERE server='$search_string'"; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM zone_cname WHERE server LIKE '$search_string' "; }
		}
		// we are searching for mx records
		elseif ($search_field == "mx") {
			// Creat our base sql statement
			if ($search_type == "exact") { $sql = "SELECT * FROM zone_mx WHERE name='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM zone_mx WHERE name LIKE '$search_string' "; }
		}
	       // we are looking fo the server name of mx records
		elseif ($search_field == "mxserver") {
			// create our base sql statemnet
			if ($search_type == "exact") { $sql = "SELECT * FROM zone_mx WHERE server='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM zone_mx WHERE server LIKE '$search_string' "; }
		}
		// Create the inital query if they are searching for a specific IP
		elseif ($search_field == "ip") {
			// Create our base sql statement
			$ip = new IP();
			$ipint = $ip->ip2int($search_string);
			$sql = "SELECT id FROM host WHERE ip='$ipint' ";
		}
		// We are looking for workgroups based on name
		elseif ($search_field == 'workgroup_name') {
			if ($search_type == 'exact') { $sql = "SELECT * FROM workgroup WHERE name='$search_string' "; }
			elseif ($search_type == 'fuzzy') { $sql = "SELECT * FROM workgroup WHERE name LIKE '$search_string' "; }
		}
		// If were not searching by IP,cname or mx then.....
		else {
			if ($search_type == "exact") { $sql = "SELECT * FROM host WHERE $search_field='$search_string' "; }
			elseif ($search_type == "fuzzy") { $sql = "SELECT * FROM host WHERE $search_field LIKE '$search_string' "; }
		}

		/*
		#######################################
		Generate the Add-on SQL Statements
		#######################################
		*/

	       // once we've created the base sql statements let's add on the zone goodies!
		if ($oldsql) {
			// if this is set we've passed in a sql statement and we don't want to foobe it anymore
		}
		elseif ($search_zone == "all") {
			//we don't need to add any contraints on the search
		}
		elseif ($search_field =="range_search" and $search_zone !="all") 
		{
			// This particular search is completely different than the rest because the
			// ranges do not have a key pointing to their zone, they use a zone_range table
			$zones = $user->zones();
			$ip_start = IP::ip2int($search_string[0]);
			$ip_end = IP::ip2int($search_string[1]);
			$sql = "SELECT ranges.id FROM ranges, zone_range  WHERE ranges.id = zone_range.range AND ranges.end <= '$ip_end' AND ranges.start >=  '$ip_start'";

			if ($search_zone == "mine") {
				foreach ($zones as $zone)
				{
					if (substr_count($sql, " zone_range.zone='") ) { $sql .= " OR zone_range.zone='$zone->id'"; }
					elseif (!substr_count($sql, " zone_range.zone='")) { $sql .= " AND ( zone_range.zone='$zone->id' "; }
				}
				$sql .=")";
			}
			else {
				$sql .= " AND zone_range.zone='$search_zone'";
			}

		}
		elseif ($search_zone == "mine" and $search_field != "domain" and $search_field != "domain_name" AND $search_field !='range_search') {
			$zones = $user->zones();

			foreach ($zones as $zone)
			{
				if (substr_count($sql, " zone='") ) { $sql .= " OR zone='$zone->id'"; }
				elseif (!substr_count($sql, " zone='")) { $sql .= " AND ( zone='$zone->id' "; }
			}
			$sql .=")";
		}
		else
		{
			if ($search_field != "domain" and $search_field != "domain_name") { $sql .= "AND zone='$search_zone'"; }
		}
		
		/*
		#######################################
		Generate the View Object
		#######################################
		*/

		// Once were done creating the sql query create the view
		if (!$user->view) {
			$user->view = new View($sql);
		}

		if ($sort_type) {
			$user->view->initialize($sort_type,$sort_offset);
		}
		elseif ($search_field == "ip" or $search_field == "fuzzy_ip") {
			$user->view->initialize('ip', $sort_offset);
		}
		elseif ($search_field == "domain_name") {
			$user->view->initialize('host.id',$sort_offset);
		}
		else {
			$user->view->initialize('id', $sort_offset);
		}
		
		/*
		#######################################
		Get the Objects into $results
		#######################################
		*/
		

		//depending upon the different types of searches create the correct object
		if ($search_field == "cname" || $search_field == "cserver" || $search_field == "fqd_cname") {
			$results = $conf['ui']->get_cnames();
		}

		elseif ($search_field == "mx" || $search_field == "mxserver" || $search_field == "fqd_mx") {
			$results = $conf['ui']->get_mxs();
		}		 

		elseif ($search_field == "domain") {
			$results = $conf['ui']->get_domains();
		}

		elseif ($search_field == "user") {
			$results = $conf['ui']->get_users();
		}
		
		elseif ($search_field == "range_search") {
			$results = $conf['ui']->get_ranges();
		}
		elseif ($search_field == 'workgroup_name') {
			$results = $conf['ui']->get_workgroups();
		}
		else {
			$results = $conf['ui']->get_hosts();
		}
		
		/*
		#######################################
		DONE!
		#######################################
		*/

	return $results;

	} //search function 

} // class Search

?>
